DevExtreme v23.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.
Select Box

Grouped Items

Data items in the SelectBox's drop-down list can be organized in groups.

If the data source contains ungrouped data items, use the DataSource's group property to specify the data field to group by. This case is illustrated in this demo's first and third SelectBoxes.

The SelectBox can also work with initially grouped data items. In this case, the data array should contain objects with the key and items fields:

let dataSource = [{
    key: "Group 1", // Group caption 
    items: [ // Items in Group 1
        { /* ... */ },
        { /* ... */ }
    ]
}, {
    key: "Group 2",
    items: [
        { /* ... */ },
        { /* ... */ }
    ]
}];

If data objects are grouped but use other field names, implement the DataSource's map function to create key and items field mappings as in this demo's second SelectBox.

NOTE

Only one-level grouping is supported.

Regardless of the data source structure, enable the grouped property.

If the data source contains objects, specify the following SelectBox properties:

  • valueExpr
    A data field that contains unique values used to identify items.

  • displayExpr
    A data field whose values should be displayed in the drop-down list.

If you need to specify a custom template for group captions, use the groupTemplate property. In this demo, each caption contains an icon and a text string.

Backend API
Copy to CodePen
Apply
Reset
$(() => { const fromUngroupedData = new DevExpress.data.DataSource({ store: { type: 'array', data: ungroupedData, key: 'ID', }, group: 'Category', }); const fromPregroupedData = new DevExpress.data.DataSource({ store: { type: 'array', data: pregroupedData, key: 'ID', }, map(item) { item.key = item.Category; item.items = item.Products; return item; }, }); fromPregroupedData.load(); $('#selectbox-ungroupeddata').dxSelectBox({ dataSource: fromUngroupedData, inputAttr: { 'aria-label': 'Data' }, valueExpr: 'ID', grouped: true, displayExpr: 'Name', value: 1, }); $('#selectbox-pregroupeddata').dxSelectBox({ dataSource: fromPregroupedData, inputAttr: { 'aria-label': 'Pregrouped Data' }, valueExpr: 'ID', grouped: true, displayExpr: 'Name', value: 1, }); $('#selectbox-template').dxSelectBox({ dataSource: fromUngroupedData, valueExpr: 'ID', inputAttr: { 'aria-label': 'Templated Ungrouped Data' }, grouped: true, groupTemplate(data) { return $(`<div class='custom-icon'><span class='dx-icon-box icon'></span> ${data.key}</div>`); }, displayExpr: 'Name', value: 1, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" /> <script src="https://cdn3.devexpress.com/jslib/23.1.5/js/dx.all.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="dx-fieldset"> <div class="dx-field"> <div class="dx-field-label">Data grouped in the DataSource</div> <div class="dx-field-value"> <div id="selectbox-ungroupeddata"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">Pre-grouped data</div> <div class="dx-field-value"> <div id="selectbox-pregroupeddata"></div> </div> </div> <div class="dx-field"> <div class="dx-field-label">Custom group template</div> <div class="dx-field-value"> <div id="selectbox-template"></div> </div> </div> </div> </div> </body> </html>
.custom-icon .icon { font-size: 17px; color: #f05b41; margin-right: 2px; }
const ungroupedData = [{ ID: 1, Name: 'HD Video Player', Category: 'Video Players', }, { ID: 2, Name: 'SuperHD Player', Category: 'Video Players', }, { ID: 3, Name: 'SuperPlasma 50', Category: 'Televisions', }, { ID: 4, Name: 'SuperLED 50', Category: 'Televisions', }, { ID: 5, Name: 'SuperLED 42', Category: 'Televisions', }, { ID: 6, Name: 'SuperLCD 55', Category: 'Televisions', }, { ID: 7, Name: 'SuperLCD 42', Category: 'Televisions', }, { ID: 8, Name: 'SuperPlasma 65', Category: 'Televisions', }, { ID: 9, Name: 'SuperLCD 70', Category: 'Televisions', }, { ID: 10, Name: 'DesktopLED 21', Category: 'Monitors', }, { ID: 11, Name: 'DesktopLED 19', Category: 'Monitors', }, { ID: 12, Name: 'DesktopLCD 21', Category: 'Monitors', }, { ID: 13, Name: 'DesktopLCD 19', Category: 'Monitors', }, { ID: 14, Name: 'Projector Plus', Category: 'Projectors', }, { ID: 15, Name: 'Projector PlusHD', Category: 'Projectors', }, { ID: 16, Name: 'Projector PlusHT', Category: 'Projectors', }, { ID: 17, Name: 'ExcelRemote IR', Category: 'Automation', }, { ID: 18, Name: 'ExcelRemote BT', Category: 'Automation', }, { ID: 19, Name: 'ExcelRemote IP', Category: 'Automation', }]; const pregroupedData = [{ Category: 'Video Players', Products: [{ ID: 1, Name: 'HD Video Player', }, { ID: 2, Name: 'SuperHD Player', }], }, { Category: 'Televisions', Products: [{ ID: 3, Name: 'SuperPlasma 50', }, { ID: 4, Name: 'SuperLED 50', }, { ID: 5, Name: 'SuperLED 42', }, { ID: 6, Name: 'SuperLCD 55', }, { ID: 7, Name: 'SuperLCD 42', }, { ID: 8, Name: 'SuperPlasma 65', }, { ID: 9, Name: 'SuperLCD 70', }], }, { Category: 'Monitors', Products: [{ ID: 10, Name: 'DesktopLED 21', }, { ID: 11, Name: 'DesktopLED 19', }, { ID: 12, Name: 'DesktopLCD 21', }, { ID: 13, Name: 'DesktopLCD 19', }], }, { Category: 'Projectors', Products: [{ ID: 14, Name: 'Projector Plus', }, { ID: 15, Name: 'Projector PlusHD', }, { ID: 16, Name: 'Projector PlusHT', }], }, { Category: 'Automation', Products: [{ ID: 17, Name: 'ExcelRemote IR', }, { ID: 18, Name: 'ExcelRemote BT', }, { ID: 19, Name: 'ExcelRemote IP', }], }];

<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Data grouped in the DataSource</div>
<div class="dx-field-value">
<dx-select-box
[dataSource]="fromUngroupedData"
valueExpr="ID"
[grouped]="true"
displayExpr="Name"
></dx-select-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Pre-grouped data</div>
<div class="dx-field-value">
<dx-select-box
[dataSource]="fromPregroupedData"
valueExpr="ID"
[grouped]="true"
displayExpr="Name"
></dx-select-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Custom group template</div>
<div class="dx-field-value">
<dx-select-box
[dataSource]="fromUngroupedData"
valueExpr="ID"
[grouped]="true"
displayExpr="Name"
[searchEnabled]="true"
groupTemplate="group"
>
<div *dxTemplate="let data of 'group'">
<div class="custom-icon">
<span class="dx-icon-box icon"></span>
{{ data.key }}
</div>
</div>
</dx-select-box>
</div>
</div>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import DataSource from 'devextreme/data/data_source';
import ArrayStore from 'devextreme/data/array_store';
import {
DxSelectBoxModule,
} from 'devextreme-angular';
import { Product, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service],
})
export class AppComponent {
fromUngroupedData: DataSource;
fromPregroupedData: DataSource;
constructor(service: Service) {
this.fromUngroupedData = new DataSource({
store: new ArrayStore({
data: service.getUngroupedData(),
key: 'ID',
}),
group: 'Category',
});
this.fromPregroupedData = new DataSource({
store: new ArrayStore({
data: service.getPregroupedData(),
key: 'ID',
}),
map(item) {
item.key = item.Category;
item.items = item.Products;
return item;
},
});
}
}
@NgModule({
imports: [
BrowserModule,
DxSelectBoxModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule {
}
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .custom-icon .icon {
font-size: 17px;
color: #f05b41;
margin-right: 2px;
}
import { Injectable } from '@angular/core';
export class Product {
ID: number;
Name: string;
Category: string;
}
export class ProductGrouped {
ID: number;
Name: string;
}
export class CategoryGrouped {
Category: string;
Products: ProductGrouped[];
}
const ungroupedData: Product[] = [{
ID: 1,
Name: 'HD Video Player',
Category: 'Video Players',
}, {
ID: 2,
Name: 'SuperHD Player',
Category: 'Video Players',
}, {
ID: 3,
Name: 'SuperPlasma 50',
Category: 'Televisions',
}, {
ID: 4,
Name: 'SuperLED 50',
Category: 'Televisions',
}, {
ID: 5,
Name: 'SuperLED 42',
Category: 'Televisions',
}, {
ID: 6,
Name: 'SuperLCD 55',
Category: 'Televisions',
}, {
ID: 7,
Name: 'SuperLCD 42',
Category: 'Televisions',
}, {
ID: 8,
Name: 'SuperPlasma 65',
Category: 'Televisions',
}, {
ID: 9,
Name: 'SuperLCD 70',
Category: 'Televisions',
}, {
ID: 10,
Name: 'DesktopLED 21',
Category: 'Monitors',
}, {
ID: 11,
Name: 'DesktopLED 19',
Category: 'Monitors',
}, {
ID: 12,
Name: 'DesktopLCD 21',
Category: 'Monitors',
}, {
ID: 13,
Name: 'DesktopLCD 19',
Category: 'Monitors',
}, {
ID: 14,
Name: 'Projector Plus',
Category: 'Projectors',
}, {
ID: 15,
Name: 'Projector PlusHD',
Category: 'Projectors',
}, {
ID: 16,
Name: 'Projector PlusHT',
Category: 'Projectors',
}, {
ID: 17,
Name: 'ExcelRemote IR',
Category: 'Automation',
}, {
ID: 18,
Name: 'ExcelRemote BT',
Category: 'Automation',
}, {
ID: 19,
Name: 'ExcelRemote IP',
Category: 'Automation',
}];
const pregroupedData: CategoryGrouped[] = [{
Category: 'Video Players',
Products: [{
ID: 1,
Name: 'HD Video Player',
}, {
ID: 2,
Name: 'SuperHD Player',
}],
}, {
Category: 'Televisions',
Products: [{
ID: 3,
Name: 'SuperPlasma 50',
}, {
ID: 4,
Name: 'SuperLED 50',
}, {
ID: 5,
Name: 'SuperLED 42',
}, {
ID: 6,
Name: 'SuperLCD 55',
}, {
ID: 7,
Name: 'SuperLCD 42',
}, {
ID: 8,
Name: 'SuperPlasma 65',
}, {
ID: 9,
Name: 'SuperLCD 70',
}],
}, {
Category: 'Monitors',
Products: [{
ID: 10,
Name: 'DesktopLED 21',
}, {
ID: 11,
Name: 'DesktopLED 19',
}, {
ID: 12,
Name: 'DesktopLCD 21',
}, {
ID: 13,
Name: 'DesktopLCD 19',
}],
}, {
Category: 'Projectors',
Products: [{
ID: 14,
Name: 'Projector Plus',
}, {
ID: 15,
Name: 'Projector PlusHD',
}, {
ID: 16,
Name: 'Projector PlusHT',
}],
}, {
Category: 'Automation',
Products: [{
ID: 17,
Name: 'ExcelRemote IR',
}, {
ID: 18,
Name: 'ExcelRemote BT',
}, {
ID: 19,
Name: 'ExcelRemote IP',
}],
}];
@Injectable()
export class Service {
getUngroupedData(): Product[] {
return ungroupedData;
}
getPregroupedData(): CategoryGrouped[] {
return pregroupedData;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.3.5/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.16',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.16',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.16',
'@angular/forms': 'npm:@angular/forms@12.2.16',
'@angular/common': 'npm:@angular/common@12.2.16',
'@angular/compiler': 'npm:@angular/compiler@12.2.16',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@6.4.0',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@21.2.7/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@21.2.7/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.14/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.47',
'devexpress-gantt': 'npm:devexpress-gantt@4.0.13',
'devextreme-angular': 'npm:devextreme-angular@21.2.7',
'@devextreme/runtime': 'npm:@devextreme/runtime@2.3.14',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@2.3.14/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.16/*/package.json',
'npm:rxjs@6.4.0/package.json',
'npm:rxjs@6.4.0/operators/package.json',
'npm:devextreme-angular@21.2.7/*/package.json',
'npm:devextreme-angular@21.2.7/ui/*/package.json',
'npm:devextreme-angular@21.2.7/package.json',
'npm:devexpress-diagram@2.1.47/package.json',
'npm:devexpress-gantt@4.0.13/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.11.4/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Data grouped in the DataSource</div>
<div class="dx-field-value">
<DxSelectBox
:data-source="fromUngroupedData"
:grouped="true"
display-expr="Name"
value-expr="ID"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Pre-grouped data</div>
<div class="dx-field-value">
<DxSelectBox
:data-source="fromPregroupedData"
:grouped="true"
display-expr="Name"
value-expr="ID"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Custom group template</div>
<div class="dx-field-value">
<DxSelectBox
:data-source="fromUngroupedData"
:grouped="true"
display-expr="Name"
value-expr="ID"
>
<template #group="{ data }">
<Group :item-data="data"/>
</template>
</DxSelectBox>
</div>
</div>
</div>
</template>
<script>
import { DxSelectBox } from 'devextreme-vue/select-box';
import DataSource from 'devextreme/data/data_source';
import Group from './Group.vue';
import { ungroupedData, pregroupedData } from './data.js';
export default {
components: {
DxSelectBox,
Group
},
data() {
return {
fromUngroupedData: new DataSource({
store: ungroupedData,
key: 'ID',
group: 'Category'
}),
fromPregroupedData: new DataSource({
store: pregroupedData,
map: function(item) {
item.key = item.Category;
item.items = item.Products;
return item;
}
})
};
}
};
</script>
<template>
<div class="custom-icon">
<span class="dx-icon-box icon"/>
{{ itemData.key }}
</div>
</template>
<script>
export default {
props: {
itemData: {
type: Object,
default: () => {}
}
}
};
</script>
<style scoped>
.custom-icon .icon {
font-size: 17px;
color: #f05b41;
margin-right: 2px;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app">
</div>
</div>
</body>
</html>
export const ungroupedData = [{
'ID': 1,
'Name': 'HD Video Player',
'Category': 'Video Players'
}, {
'ID': 2,
'Name': 'SuperHD Player',
'Category': 'Video Players'
}, {
'ID': 3,
'Name': 'SuperPlasma 50',
'Category': 'Televisions'
}, {
'ID': 4,
'Name': 'SuperLED 50',
'Category': 'Televisions'
}, {
'ID': 5,
'Name': 'SuperLED 42',
'Category': 'Televisions'
}, {
'ID': 6,
'Name': 'SuperLCD 55',
'Category': 'Televisions'
}, {
'ID': 7,
'Name': 'SuperLCD 42',
'Category': 'Televisions'
}, {
'ID': 8,
'Name': 'SuperPlasma 65',
'Category': 'Televisions'
}, {
'ID': 9,
'Name': 'SuperLCD 70',
'Category': 'Televisions'
}, {
'ID': 10,
'Name': 'DesktopLED 21',
'Category': 'Monitors'
}, {
'ID': 11,
'Name': 'DesktopLED 19',
'Category': 'Monitors'
}, {
'ID': 12,
'Name': 'DesktopLCD 21',
'Category': 'Monitors'
}, {
'ID': 13,
'Name': 'DesktopLCD 19',
'Category': 'Monitors'
}, {
'ID': 14,
'Name': 'Projector Plus',
'Category': 'Projectors'
}, {
'ID': 15,
'Name': 'Projector PlusHD',
'Category': 'Projectors'
}, {
'ID': 16,
'Name': 'Projector PlusHT',
'Category': 'Projectors'
}, {
'ID': 17,
'Name': 'ExcelRemote IR',
'Category': 'Automation'
}, {
'ID': 18,
'Name': 'ExcelRemote BT',
'Category': 'Automation'
}, {
'ID': 19,
'Name': 'ExcelRemote IP',
'Category': 'Automation'
}];
export const pregroupedData = [{
'Category': 'Video Players',
'Products': [{
'ID': 1,
'Name': 'HD Video Player'
}, {
'ID': 2,
'Name': 'SuperHD Player'
}],
}, {
'Category': 'Televisions',
'Products': [{
'ID': 3,
'Name': 'SuperPlasma 50'
}, {
'ID': 4,
'Name': 'SuperLED 50'
}, {
'ID': 5,
'Name': 'SuperLED 42'
}, {
'ID': 6,
'Name': 'SuperLCD 55'
}, {
'ID': 7,
'Name': 'SuperLCD 42'
}, {
'ID': 8,
'Name': 'SuperPlasma 65'
}, {
'ID': 9,
'Name': 'SuperLCD 70'
}]
}, {
'Category': 'Monitors',
'Products': [{
'ID': 10,
'Name': 'DesktopLED 21'
}, {
'ID': 11,
'Name': 'DesktopLED 19'
}, {
'ID': 12,
'Name': 'DesktopLCD 21'
}, {
'ID': 13,
'Name': 'DesktopLCD 19'
}]
}, {
'Category': 'Projectors',
'Products': [{
'ID': 14,
'Name': 'Projector Plus'
}, {
'ID': 15,
'Name': 'Projector PlusHD'
}, {
'ID': 16,
'Name': 'Projector PlusHT'
}]
}, {
'Category': 'Automation',
'Products': [{
'ID': 17,
'Name': 'ExcelRemote IR'
}, {
'ID': 18,
'Name': 'ExcelRemote BT'
}, {
'ID': 19,
'Name': 'ExcelRemote IP'
}]
}];
System.config({
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader'
},
'devextreme/localization.js': {
"esModule": true
},
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.26.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.6',
'devextreme-vue': 'npm:devextreme-vue@20.2.6',
'jszip': 'npm:jszip@3.6.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.10.3/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.18/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.24/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.13/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.13/hooks/dist/hooks.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme-vue': {
main: 'index.js'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true
}
});

import React from 'react';
import { SelectBox } from 'devextreme-react/select-box';
import DataSource from 'devextreme/data/data_source';
import Group from './Group.js';
import { ungroupedData, pregroupedData } from './data.js';
const fromUngroupedData = new DataSource({
store: {
type: 'array',
data: ungroupedData,
key: 'ID',
},
group: 'Category',
});
const fromPregroupedData = new DataSource({
store: {
type: 'array',
data: pregroupedData,
key: 'ID',
},
map(item) {
item.key = item.Category;
item.items = item.Products;
return item;
},
});
class App extends React.Component {
render() {
return (
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Data grouped in the DataSource</div>
<div className="dx-field-value">
<SelectBox
dataSource={fromUngroupedData}
valueExpr="ID"
grouped={true}
displayExpr="Name" />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Pre-grouped data</div>
<div className="dx-field-value">
<SelectBox
dataSource={fromPregroupedData}
valueExpr="ID"
grouped={true}
displayExpr="Name" />
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Custom group template</div>
<div className="dx-field-value">
<SelectBox
dataSource={fromUngroupedData}
valueExpr="ID"
grouped={true}
displayExpr="Name"
groupRender={Group} />
</div>
</div>
</div>
);
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.custom-icon .icon {
font-size: 17px;
color: #f05b41;
margin-right: 2px;
}
import React from 'react';
export default function Group({ key }) {
return (
<div className="custom-icon">
<span className="dx-icon-box icon"></span>{' '}
{key}
</div>
);
}
export const ungroupedData = [{
ID: 1,
Name: 'HD Video Player',
Category: 'Video Players',
}, {
ID: 2,
Name: 'SuperHD Player',
Category: 'Video Players',
}, {
ID: 3,
Name: 'SuperPlasma 50',
Category: 'Televisions',
}, {
ID: 4,
Name: 'SuperLED 50',
Category: 'Televisions',
}, {
ID: 5,
Name: 'SuperLED 42',
Category: 'Televisions',
}, {
ID: 6,
Name: 'SuperLCD 55',
Category: 'Televisions',
}, {
ID: 7,
Name: 'SuperLCD 42',
Category: 'Televisions',
}, {
ID: 8,
Name: 'SuperPlasma 65',
Category: 'Televisions',
}, {
ID: 9,
Name: 'SuperLCD 70',
Category: 'Televisions',
}, {
ID: 10,
Name: 'DesktopLED 21',
Category: 'Monitors',
}, {
ID: 11,
Name: 'DesktopLED 19',
Category: 'Monitors',
}, {
ID: 12,
Name: 'DesktopLCD 21',
Category: 'Monitors',
}, {
ID: 13,
Name: 'DesktopLCD 19',
Category: 'Monitors',
}, {
ID: 14,
Name: 'Projector Plus',
Category: 'Projectors',
}, {
ID: 15,
Name: 'Projector PlusHD',
Category: 'Projectors',
}, {
ID: 16,
Name: 'Projector PlusHT',
Category: 'Projectors',
}, {
ID: 17,
Name: 'ExcelRemote IR',
Category: 'Automation',
}, {
ID: 18,
Name: 'ExcelRemote BT',
Category: 'Automation',
}, {
ID: 19,
Name: 'ExcelRemote IP',
Category: 'Automation',
}];
export const pregroupedData = [{
Category: 'Video Players',
Products: [{
ID: 1,
Name: 'HD Video Player',
}, {
ID: 2,
Name: 'SuperHD Player',
}],
}, {
Category: 'Televisions',
Products: [{
ID: 3,
Name: 'SuperPlasma 50',
}, {
ID: 4,
Name: 'SuperLED 50',
}, {
ID: 5,
Name: 'SuperLED 42',
}, {
ID: 6,
Name: 'SuperLCD 55',
}, {
ID: 7,
Name: 'SuperLCD 42',
}, {
ID: 8,
Name: 'SuperPlasma 65',
}, {
ID: 9,
Name: 'SuperLCD 70',
}],
}, {
Category: 'Monitors',
Products: [{
ID: 10,
Name: 'DesktopLED 21',
}, {
ID: 11,
Name: 'DesktopLED 19',
}, {
ID: 12,
Name: 'DesktopLCD 21',
}, {
ID: 13,
Name: 'DesktopLCD 19',
}],
}, {
Category: 'Projectors',
Products: [{
ID: 14,
Name: 'Projector Plus',
}, {
ID: 15,
Name: 'Projector PlusHD',
}, {
ID: 16,
Name: 'Projector PlusHT',
}],
}, {
Category: 'Automation',
Products: [{
ID: 17,
Name: 'ExcelRemote IR',
}, {
ID: 18,
Name: 'ExcelRemote BT',
}, {
ID: 19,
Name: 'ExcelRemote IP',
}],
}];
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme-react': 'npm:devextreme-react@22.2.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);